#pragma once

#include "caosdb/filestreaming/FileLock.h"

#include <boost/filesystem.hpp>
#include <boost/filesystem/fstream.hpp>
#include <boost/filesystem/string_file.hpp>

#include <fstream>
#include <memory>
#include <string>

namespace FileExchange {

class FileWriter final {
public:
  FileWriter(const boost::filesystem::path &filename);
  FileWriter(const boost::filesystem::path &filename,
             const std::shared_ptr<FileMutex> &mutexPtr);

  ~FileWriter() = default;

  FileWriter(const FileWriter &) = delete;
  FileWriter &operator=(const FileWriter &) = delete;

  FileWriter(FileWriter &&) = default;
  FileWriter &operator=(FileWriter &&) = default;

  void write(const std::string &buffer);

private:
  void openFile();

  std::ofstream stream_;
  boost::filesystem::path filename_;

  std::shared_ptr<FileMutex> mutexPtr_;
  FileWriteLock lock_;
};

} // namespace FileExchange
